<template>
  <div class="fr-container fr-p-0">
    <AtomAlert
      v-if="error"
      :alert-type="AlertType.Error"
      message="La liste des rôles n'a pas pu être chargée."
    />
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <form
      v-else-if="roles"
      class="fr-container--fluid"
      @submit.prevent="onInviteUser"
    >
      <div class="fr-grid-row fr-grid-row--gutters form-grid">
        <AtomInput
          name="first_name"
          label="Prénom"
          required
        />
        <AtomInput
          name="last_name"
          label="Nom"
          required
        />
        <AtomInput
          name="email"
          label="Email"
          type="email"
          required
        />
        <AtomSelect
          name="role"
          label="Rôle"
          :options="options"
          required
        />
      </div>

      <button
        class="fr-btn fr-btn--lg submit-btn"
        type="submit"
        :disabled="isSubmitting"
        :submitting="isSubmitting"
      >
        Créer
      </button>
    </form>
  </div>
</template>

<script setup>
  import { toOptions, withEmptyValue } from '~/utils'
  import { useAuthStore } from '~/store/auth'
  import { DIRECTUS_UNIQUE_EMAIL_ERROR } from '~/utils/constants'
  import { AlertType } from '~/utils/constants/alert'
  import { Provider } from '~/utils/constants/user'
  import { dataObjectFromForm, formFromEvent } from '~/utils/formData'

  const props = defineProps({
    roles: {
      type: Array || Null,
      default: () => []
    },
    pending: {
      type: Boolean,
      default: true
    },
    error: {
      type: Error || Null,
      default: null
    }
  })

  const emit = defineEmits(['usersRefresh'])

  const { $apiRequest, $snackbar } = useNuxtApp()
  const authStore = useAuthStore()

  const isSubmitting = ref(false)

  const options = computed(() => {
    return withEmptyValue(toOptions(props.roles, 'id', 'name'))
  })

  async function onInviteUser(event) {
    const form = formFromEvent(event)
    isSubmitting.value = true
    const user = {
      ...dataObjectFromForm(form),
      organisation: authStore.userOrganisationId,
      provider: Provider.InclusionConnect
    }
    user.external_identifier = user.email

    try {
      const res = await $apiRequest('/users', { data: user })

      // Use ok for type inferrence
      if (res.ok) {
        onSuccess(
          `Le nouvel utilisateur ${res.data.data.email} a correctement été créé. Il recevra dans quelques instants un email l'invitant à créer son compte Inclusion Connect. Pensez à l'informer de la réception de ce mail et de l'inviter si nécessaire à vérifier ses spams.`,
          form,
          10000
        )
        form.reset()
        emit('usersRefresh')
      } else if (res.data?.errors[0].message === DIRECTUS_UNIQUE_EMAIL_ERROR) {
        onError('Cet email est déjà associé à un utilisateur.', form)
      } else throw new Error(errorResponseMessage(res))
    } catch {
      onError("La création de l'utilisateur a échoué.", form)
    } finally {
      isSubmitting.value = false
    }
  }

  function onSuccess(message, form, duration) {
    $snackbar.success(
      message,
      () => form?.querySelector('input')?.focus(),
      duration
    )
  }

  function onError(message, form) {
    $snackbar.error(message, () => form?.querySelector('input')?.focus())
  }
</script>

<style lang="scss" scoped>
  @use '@gouvfr/dsfr/src/core/index' as dsfr;
  @use '@gouvfr/dsfr/module/media-query' as dsfr-media-query;

  .form-grid > * {
    @include dsfr.grid-col(12);

    padding: 0.5rem;

    @include dsfr-media-query.respond-from('lg') {
      @include dsfr.grid-col(6);

      padding: 0.75rem;
    }
  }
</style>
